/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _TCP_H
 #define _TCP_H

//Prototype
extern unsigned int TCP_Socket_Status[];
extern unsigned int TCP_Socket_Store[];
extern PGM_P TCP_Socket_Pointer[];
extern PGM_P pointerold;
extern unsigned char Sendpage;


extern void tcp_store (char *);
extern void tcp_add_data (PGM_P ,char *,int *);
extern void tcp_add_datastring (char *pointer,char *buffer,int *bufferlen);
extern void TCP_New_Packtlen (char *buffer,int *bufferlen,unsigned int result16);
extern void tcp_make (char *);
extern void TCP_PORT_CLOSE (char *,int *);
extern int TCP_OPEN (char *,int *);
extern char TCP_Stack (char *buffer,int *bufferlen,int *Stackpointer);

#define Max_TCP_Sockets  10

//TCP Header Layout
#define	TCP_SRCPORT				0x22	//der Quellport fr die Verbindung (Socket)
#define	TCP_DESTPORT			0x24	//der Zielport fr die Verbindung (Socket)
#define	TCP_SEQNUM				0x26	//numerierter Bytestrom
#define	TCP_ACKNUM				0x2A	//numerierter Bytestrom (Gegenrichtung)
#define	TCP_HDRFLAGS			0x2E	//4Bit Lnge des Headers in 32 Bit schritten 
										//rest Flags
#define	TCP_WINDOW				0x30	//Fenstergre max. 64K Byte
#define	TCP_CHKSUM				0x32	//Enthlt eine Prfsumme ber Header und 
										//Datenbereich
#define	TCP_URGENTPTR			0x34	//16 Bit fr dringende bertragung
#define TCP_DATA				0x36	//Ab hier beginnt der Datenbereich

//TCP Flags
#define  FIN_FLAG				0x01	//Datenbertragung beendet (finished)
#define  SYN_FLAG				0x02	//Verbindungs aufbauen (synchronize)
#define  RST_FLAG				0x04	//Verbindung neu initialisieren (reset)
#define  PSH_FLAG				0x08	//Datenbergabe an Anwendung beschleunigen (push)
#define  ACK_FLAG				0x10	//Datenbertragung besttigen (acknowledged)

#endif // _TCP_H
